library dihook;

uses
  Windows, Messages, Forms, StdCtrls, SysUtils, Controls, Dialogs,
  Classes, CommCtrl, Graphics, ComCtrls, Math, xMemory;

const
  MAX_ESSAY_LINE  = 100;                      // ̤ju
  MAX_ESSAY_CHAR  = 100;                      // ̪ur

  HOOK_EVENT_NAME = 'SetWindowsHookEx_Event';
  
type
  // ưϰ, ѩҦ DLL instance @
  
  PGlobalData = ^TGlobalData;
  TGlobalData = packed record
    HHOOK: HHOOK; // Hook handle
    MainWnd: HWND; // {D handle
    
    Wnd: HWND; // I handle
    OrigWndProc: TFNWndProc; // I쥻禡
    
    ParentWnd: HWND; // I handle
    OrigParentWndProc: TFNWndProc; // I쥻禡
    
    // ୱ
    ShowDesktopWallPaper: Boolean; // O_ܮ६
    
    SeperatorColor: COLORREF; // juC
    WorkAreaRect: TRect;
    
    // uT
    Essay: array[0..MAX_ESSAY_LINE - 1, 0..MAX_ESSAY_CHAR - 1] of Char; // u
    Essay_LineCount: Integer; // 
    Essay_Font: TLogFont; // r
    Essay_Color: COLORREF; // C
  end;
  
  // ʺA, _ܤƪe
  TDynDisplay = record
    Position: TPoint; // ܦm
    
    DesktopBits, // ୱIv
    BackBits: TBitmap; // double-buffering KϨϥ
    
    DisplayString: string; // ɶr
    
    LastRect, // Wܰϰ
    CurRect: TRect; // ܰϰ
  end;
  
const
  WM_MYHOOK            = WM_APP;                   // hook wˤθѰ᪺qT
  WM_SUBCLASSED        = WM_USER;                  // subclass 禡᪺qT
  WM_BEFORE_UNSUBCLASS = WM_USER + 1;              // unsubclass 禡eqT
  
  GLOBAL_DATA_MAPNAME  = 'XDESK_HOOK_GLOBAL_DATA'; // @ file mapping W
  
  TIMER_ID             = 500;                      // pɾs
  
var
  g_Data    : PGlobalData; // V@ TGlobalData c
  MapHandle : THandle;     // file mapping handle
  
  DynDisplay: TDynDisplay; // ʺAeT
  
type
  TConfigButton = class(TButton) // ]wsO
  private
    procedure WMPaint(var message: TWMPaint); message WM_PAINT;
    procedure WMLButtonUp(var message: TWMLButtonUp); message WM_LBUTTONUP;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  end;
  
var
  ConfigButton: TConfigButton; // ]ws
  
  // øsu
procedure DrawEssay(DC: HDC);
var
  OldFont                    : HFONT;      
  OldPen                     : HPEN;       
  
  I, Y, X, MaxLen, LineHeight: Integer;    
  TextMetric                 : TTextMetric;
  
  Size                       : TSize;      
begin
  with g_Data^ do
  begin
    SetBkMode(DC, Transparent);
    SetTextColor(DC, Essay_Color);
    
    OldFont := SelectObject(DC, CreateFontIndirect(Essay_Font));
    OldPen := SelectObject(DC, CreatePen(PS_SOLID, 1, SeperatorColor));
    
    MaxLen := 0;
    for I := 0 to Essay_LineCount - 1 do
    begin
      GetTextExtentPoint32(DC, Essay[I], StrLen(Essay[I]), Size);
      if Size.cx > MaxLen then MaxLen := Size.cx;
    end;
    X := Max((Screen.Width - MaxLen) div 2, 0);
    GetTextMetrics(DC, TextMetric);
    LineHeight := TextMetric.tmHeight + TextMetric.tmExternalLeading;
    
    Y := TextMetric.tmHeight;
    for I := 0 to Essay_LineCount - 1 do
    begin
      if (StrLen(Essay[I]) = 1) and (Essay[I, 0] = '-') then
      begin
        MoveToEx(DC, X, Y + LineHeight div 2, nil);
        LineTo(DC, X + MaxLen, Y + LineHeight div 2);
      end else
        TextOut(DC, X, Y, Essay[I], StrLen(Essay[I]));
      
      Inc(Y, LineHeight);
    end;
    
    DeleteObject(SelectObject(DC, OldFont));
    DeleteObject(SelectObject(DC, OldPen));
  end;
end;

function WndProc(Window: HWND; AMessage, WPARAM, LPARAM:
    Longint): Longint; stdcall;
var
  DC             : HDC;           
  R              : TRect;         
  
  HitTestInfo    : TLVHitTestInfo;
  
  DisplaySize    : TSize;         
  
  BackgroundBrush: THandle;       
begin
  case AMessage of
    
    WM_MOUSEFIRST..WM_MOUSELAST: // dIҦƹT
    begin
      // oToͪƹЦm
      HitTestInfo.PT := Point(LOWORD(LPARAM), HiWord(LPARAM));
      
      if Assigned(ConfigButton) and (SendMessage(Window, LVM_HITTEST, 0, Integer(@HitTestInfo)) = -1) then
      begin
        // YToͦb]wsW ...
        if PtInRect(ConfigButton.BoundsRect, HitTestInfo.PT) then
        begin
          // ⦨۹ ConfigButton client area yЭ
          ClientToScreen(Window, HitTestInfo.PT);
          ScreenToClient(ConfigButton.Handle, HitTestInfo.PT);
          
          // NT浹 ConfigButton
          // b PostMessage ӥ SendMessage ]O, ƱbsBz
          // TߧYøsϰ쪺ୱ
          LPARAM := MakeLParam(HitTestInfo.PT.X, HitTestInfo.PT.Y);
          SendMessage(ConfigButton.Handle, AMessage, WPARAM, LPARAM);
          
          // øsϰ쪺ୱ
          R := ConfigButton.BoundsRect;
          InvalidateRect(Window, @R, False);
          
          // \BzT
          Result := 0;
          Exit;
        end;
      end;
    end;
    
    WM_SETTINGCHANGE, // tγ]w
    WM_SYSCOLORCHANGE: // tC(DnwୱC)
    begin
      with g_Data^ do
        SystemParametersInfo(SPI_GETWORKAREA, 0, @WorkAreaRect, 0);
      
      with DynDisplay do
      begin
        // Nୱøs DesktopBits
        PaintDesktop(DesktopBits.Canvas.Handle);
        
        // oɶrꪺܤؤo
        with BackBits.Canvas do
          DisplaySize := TextExtent(TimeToStr(Now));
        
        with g_Data^.WorkAreaRect do
        begin
          // pɶrꪺܦm
          Position := Point(Right - DisplaySize.cx - 20 - Left, Bottom - DisplaySize.cy - 20 - Top);
          // p]wsm
          ConfigButton.Left := Right - ConfigButton.Width - 20 - Left;
          ConfigButton.Top := Position.Y - ConfigButton.Height - 10;
        end;
        
        ShowWindow(ConfigButton.Handle, SW_SHOW);
      end;
    end;
    
    WM_TIMER:
      with DynDisplay do
      begin
        DisplayString := TimeToStr(Now); // oثeɶr
        
        // oɶrꪺܤؤo
        with BackBits.Canvas do
          DisplaySize := TextExtent(DisplayString);
        
        // oeΦܰϰ쪺涰
        CurRect := Rect(0, 0, DisplaySize.cx, DisplaySize.cy);
        OffsetRect(CurRect, Position.X, Position.Y);
        UnionRect(CurRect, CurRect, LastRect);
        InvalidateRect(Window, @CurRect, False);
        
        LastRect := CurRect;
        
        Result := 0;
        Exit;
      end;
      
    WM_SUBCLASSED:
    begin
      SetTimer(Window, TIMER_ID, 1000, nil);
      
      ConfigButton := TConfigButton.CreateParented(g_Data.ParentWnd);
      with ConfigButton do
      begin
        Font.name := 'sө';
        Font.Size := 11;
        Caption := ']w';
      end;
      
      with DynDisplay do
      begin
        // إxsୱv bitmap
        DesktopBits := TBitmap.Create;
        DesktopBits.Width := Screen.Width;
        DesktopBits.Height := Screen.Height;
        
        // إߥΨӰ double-buffering KϪ bitmap
        BackBits := TBitmap.Create;
        with BackBits.Canvas do
        begin
          // ]wnɶܪrΤC
          Font.Height := 48;
          Font.Color := clRed;
          Font.name := 'WA';
        end;
      end;
      
      // joୱv, ms
      SendMessage(Window, WM_SETTINGCHANGE, 0, 0);
    end;
    
    WM_BEFORE_UNSUBCLASS:
    begin
      KillTimer(Window, TIMER_ID);
      
      ConfigButton.Free;
      ConfigButton := nil;
      
      with DynDisplay do
      begin
        DesktopBits.Free;
        BackBits.Free;
      end;
    end;
    
    WM_ERASEBKGND: // MI
    begin
      DC := WPARAM; // ϥΰT DC
      
      if g_Data.ShowDesktopWallPaper then
      begin
        // Ynݨ६, NIsӪ禡
        CallWindowProc(g_Data.OrigWndProc, Window, AMessage, WPARAM, LPARAM)
      end else
      begin
        // Ynݨ६, NୱC
        R := Rect(0, 0, Screen.Width, Screen.Height);
        BackgroundBrush := CreateSolidBrush(GetSysColor(COLOR_DESKTOP));
        FillRect(DC, R, BackgroundBrush);
        DeleteObject(BackgroundBrush);
      end;
      
      // NuebIW
      if g_Data.Essay_LineCount > 0 then
        DrawEssay(DC);
      
      // ø]ws
      if Assigned(ConfigButton) then
      begin
        ConfigButton.Invalidate;
        ConfigButton.Update;
      end;
      
      // IM
      Result := 1;
      Exit;
    end;
    
  end;
  
  Result := CallWindowProc(g_Data.OrigWndProc, Window,
    AMessage, WPARAM, LPARAM);
end;


function ParentWndProc(Window: HWND; AMessage, WPARAM, LPARAM:
    Longint): Longint; stdcall;
var
  NMHdr     : PNMHdr;
  RSrc, RDst: TRect; 
begin
  case AMessage of
    WM_NOTIFY:
    begin
      NMHdr := PNMHdr(LPARAM);
      case NMHdr^.Code of
        // ListView iøsɷ|e WM_NOTIFY T
        // ʧ@NX NM_CUSTOMDRAW
        NM_CUSTOMDRAW:
          with PNMLVCustomDraw(NMHdr)^.nmcd do
          begin
            with DynDisplay do
            begin
              // Yxΰϰ, hܧ BackBits jp
              with CurRect do
                if (BackBits.Width <> (Right - Left)) or (BackBits.Height <> (Bottom - Top)) then
                begin
                  BackBits.Width := Right - Left;
                  BackBits.Height := Bottom - Top;
                end;
              
              RSrc := Rect(0, 0, BackBits.Width, BackBits.Height);
              
              if g_Data.ShowDesktopWallPaper then // Ynܮ६
              begin
                // NI BackBits
                RDst := RSrc;
                with g_Data^.WorkAreaRect do
                  OffsetRect(RDst, Position.X + Left, Position.Y + Top);
                BackBits.Canvas.CopyRect(RSrc, DesktopBits.Canvas, RDst);
              end;
              
              with BackBits.Canvas do
              begin
                // Ynܮ६, ĳzKr
                if g_Data.ShowDesktopWallPaper then
                begin
                  Brush.Style := bsClear;
                end else
                begin
                  // _hNv񺡭I
                  Brush.Style := bsSolid;
                  Brush.Color := clBackground;
                end;
                
                // b BackBits WøXɶr
                TextRect(RSrc, 0, 0, DisplayString);
                
                // ̫N BackBits KୱW
                BitBlt(HDC, Position.X, Position.Y, BackBits.Width, BackBits.Height,
                  Handle, 0, 0, SRCCOPY);
              end;
            end;
            
            // i楿`øsʧ@
            Result := CDRF_DODEFAULT;
            Exit;
          end;
      end;
    end;
  end;
  
  Result := CallWindowProc(g_Data.OrigParentWndProc, Window,
    AMessage, WPARAM, LPARAM);
end;

function GetMsgProc(Code: Integer; WPARAM: WPARAM; LPARAM: LPARAM):
    LRESULT; stdcall;
const
  bFirstCalled: Boolean = True;
var
  hEvent: THandle;
begin
  if Code = HC_ACTION then // ʧ@NX HC_ACTION ɤ~Bz
  begin
    if bFirstCalled then // Ĥ@Isɶi subclassing
    begin
      bFirstCalled := False;

      // subclass I
      g_Data.OrigWndProc := TFNWndProc(SetWindowLong(g_Data.Wnd, GWL_WNDPROC, Longint(@WndProc)));

      // subclass I
      g_Data.ParentWnd := GetParent(g_Data.Wnd);
      g_Data.OrigParentWndProc := TFNWndProc(SetWindowLong(g_Data.ParentWnd, GWL_WNDPROC, Longint(@ParentWndProc)));

      // iI, wQ subclass
      PostMessage(g_Data.Wnd, WM_SUBCLASSED, 0, 0);

      InvalidateRect(g_Data.Wnd, nil, True); // ø ListView 

      // i hook {ǧ
      PostThreadMessage(PMsg(LPARAM)^.WPARAM, WM_MYHOOK, 0, 0);

      // ն}ҫO@ hook handle  event
      hEvent := OpenEvent(Synchronize, False, HOOK_EVENT_NAME);
      if hEvent <> 0 then // pG}Ҧ\,  hook handle |QgJ
      begin
        WaitForSingleObject(hEvent, INFINITE); //  hook handle TwU
        CloseHandle(hEvent); //  event
      end;
    end else if PMsg(LPARAM)^.message = WM_MYHOOK then
    begin
      // qI, Nn unsubclass
      SendMessage(g_Data.Wnd, WM_BEFORE_UNSUBCLASS, 0, 0);
      
      // unsubclass I
      SetWindowLong(g_Data.Wnd, GWL_WNDPROC, Longint(g_Data.OrigWndProc));
      // unsubclass I
      SetWindowLong(g_Data.ParentWnd, GWL_WNDPROC, Longint(g_Data.OrigParentWndProc));

      InvalidateRect(g_Data.Wnd, nil, True); // ø ListView 
      
      // i unhook {ǧ    
      PostThreadMessage(PMsg(LPARAM)^.WPARAM, WM_MYHOOK, 0, 0);
    end;
  end;
  
  // IsU@ hook 禡
  Result := CallNextHookEx(g_Data.HHOOK, Code, WPARAM, LPARAM);
end;

procedure SetMainWindow(Wnd: HWND); stdcall;
begin
  g_Data.MainWnd := Wnd;
end;

function SetDeskHook(Wnd: HWND): Boolean; stdcall;
var
  ThreadId: DWORD;
  Msg     : TMsg;
  hEvent  : THandle;
begin
  Result := False;

  if Wnd <> 0 then
  begin
    if g_Data.HHOOK <> 0 then
    begin
      ShowMessage('Window is already subclassed.');
      Exit;
    end;
    
    // o ID
    g_Data.Wnd := Wnd;
    ThreadId := GetWindowThreadProcessId(g_Data.Wnd, nil);

    // إ߫O@ hook handle  event
    hEvent := CreateEvent(nil, True, False, HOOK_EVENT_NAME);
    // w WH_GETMESSAGE hook
    g_Data.HHOOK := SetWindowsHookEx(WH_GETMESSAGE, GetMsgProc, HInstance, ThreadId);
    // N event ] signaled A, Y hook 禡b, q,
    // hook handle wg ready
    SetEvent(hEvent);
    //  event
    CloseHandle(hEvent);

    if g_Data.HHOOK <> 0 then // Y hook w˦\
    begin
      // @ӵLΰTLh, T{ hook 禡QIs
      // P subclass IΨ
      PostThreadMessage(ThreadId, WM_NULL, GetCurrentThreadId, 0);

      //  Hook ˳],  Hook {ǰe^ WM_MYHOOK Tq
      repeat
        GetMessage(Msg, 0, 0, 0);
      until Msg.message = WM_MYHOOK;

      Result := True;
    end;
  end else
  begin
    if g_Data.HHOOK <> 0 then
    begin
      ThreadId := GetWindowThreadProcessId(g_Data.Wnd, nil);
      // i hook 禡, Х unsubclass, ǳƭn unhook F
      PostThreadMessage(ThreadId, WM_MYHOOK, GetCurrentThreadId, 0);
      
      // Tw GetMsgProc wNIΨ unsubclassing ..
      repeat
        GetMessage(Msg, 0, 0, 0);
      until Msg.message = WM_MYHOOK;
      
      //  hook 禡
      UnhookWindowsHookEx(g_Data.HHOOK);
      
      g_Data.HHOOK := 0;
      
      Result := True;
    end;
  end;
end;

procedure SetShowDesktopWallPaper(Value: Boolean); stdcall;
begin
  g_Data.ShowDesktopWallPaper := Value;
  InvalidateRect(g_Data.Wnd, nil, True);
end;

procedure SetEssay(index: Integer; Str: PChar); stdcall;
begin
  if index < MAX_ESSAY_LINE then
    StrLCopy(g_Data.Essay[index], Str, MAX_ESSAY_CHAR - 1);
end;

procedure SetEssayCount(Count: Integer); stdcall;
begin
  g_Data.Essay_LineCount := Min(Count, MAX_ESSAY_LINE);
  InvalidateRect(g_Data.Wnd, nil, True);
end;

procedure SetEssayFont(LF: PLogFont); stdcall;
begin
  Move(LF^, g_Data.Essay_Font, SizeOf(TLogFont));
  InvalidateRect(g_Data.Wnd, nil, True);
end;

procedure SetEssayColor(SepColor, TextColor: COLORREF); stdcall;
begin
  g_Data.SeperatorColor := SepColor;
  g_Data.Essay_Color := TextColor;
  
  InvalidateRect(g_Data.Wnd, nil, True);
end;

exports
  SetMainWindow,
  SetDeskHook,
  SetShowDesktopWallPaper,
  SetEssay,
  SetEssayCount,
  SetEssayFont,
  SetEssayColor;

procedure MyDLLHandler(Reason: Integer);
begin
  case Reason of
    DLL_PROCESS_ATTACH:
      MapHandle := MapGlobalData(GLOBAL_DATA_MAPNAME, SizeOf(TGlobalData), Pointer(g_Data));
      
    DLL_PROCESS_DETACH:
      ReleaseGlobalData(MapHandle, Pointer(g_Data));
      
    DLL_THREAD_ATTACH:;
    DLL_THREAD_DETACH:;
  end;
end;

{ TConfigButton }

procedure TConfigButton.WMLButtonUp(var message: TWMLButtonUp);
begin
  inherited;
  
  if (g_Data.MainWnd <> 0) then // ܳ]w
  begin
    if IsWindowVisible(g_Data.MainWnd) then
      SetForegroundWindow(g_Data.MainWnd)
    else
      ShowWindow(g_Data.MainWnd, SW_SHOW);
  end;
end;

procedure TConfigButton.WMPaint(var message: TWMPaint);
var
  R: TRect;
begin
  inherited;
  
  // s\bୱϥܤW, Ysø, ]øWୱϥ
  R := BoundsRect;
  InvalidateRect(g_Data.Wnd, @R, False);
end;

procedure TConfigButton.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  
  with Params do
  begin
    Style := Style and not WS_CLIPSIBLINGS; // ݭnޥS̵, ӵe~
  end;
end;

begin
  DLLProc := @MyDLLHandler;
  MyDLLHandler(DLL_PROCESS_ATTACH);
end.

