unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    btnSetWorkarea: TButton;
    btnRelease: TButton;
    procedure btnSetWorkareaClick(Sender: TObject);
    procedure btnReleaseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FOldWorkarea: TRect;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnSetWorkareaClick(Sender: TObject);
var
  R: TRect;
begin
  R := BoundsRect;
  SystemParametersInfo(SPI_SETWORKAREA, 0, @R, SPIF_UPDATEINIFILE);
end;

procedure TForm1.btnReleaseClick(Sender: TObject);
begin
  SystemParametersInfo(SPI_SETWORKAREA, 0, @FOldWorkarea, SPIF_UPDATEINIFILE);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SystemParametersInfo(SPI_GETWORKAREA, 0, @FOldWorkarea, 0);
end;

end.
