program XEssay;

uses
  Forms,
  Dialogs,
  SysUtils,
  Windows,
  main in 'main.pas' {MainForm},
  drawthrd in 'drawthrd.pas',
  savercfg in 'savercfg.pas' {ConfigForm},
  util in 'util.pas',
  prevfrm in 'prevfrm.pas' {PreviewForm};

{$E .SCR}

{$R *.RES}
{$R TITLE.RES}

procedure ParseParameter;
  
  // NĤGӰѼনƦsJ ParamHandle ܼ
  function SetParamHandle: Boolean;
  begin
    Result := ParamCount > 1;
    try
      if Result then
        ParamHandle := StrToInt(ParamStr(2));
    except
      Result := False;
    end;
  end;
  
var
  Param: string;
begin
  ParentHandle := 0;
  
  if ParamCount = 0 then // SѼ => ]wҦ
    SaverMode := smConfig
  else
  begin
    Param := UpperCase(ParamStr(1));
    
    // YĤ@ӦrO^r, NR
    if (Param[1] < 'A') or (Param[1] > 'Z') then Delete(Param, 1, 1);
    
    case Param[1] of
      'C':
      begin
        SaverMode := smConfig;
        ParentHandle := GetForegroundWindow;
      end;
      
      'P': if SetParamHandle then // Y\ow handle
        SaverMode := smPreview; // iJwҦ
    else
      SaverMode := smSaver; // _hiJùO@Ҧ
    end;
  end;
end;

var
  R: TRect;
begin
  // RѼ, ھڰѼƭק SaverMode
  ParseParameter;
  
  // ھڤRGOiJPҦ
  case SaverMode of
    smSaver:
    begin
      Application.Initialize;
      Application.CreateForm(TMainForm, MainForm);
      Application.Run;
    end;
    
    smConfig:
      with TConfigForm.Create(nil) do
        try
          ShowModal;
        finally
          Free;
        end;
      
    smPreview:
    begin
      PreviewSaver;
      
      {
      //  ϥ TForm @k
      with TPreviewForm.CreateParented(ParamHandle) do
        try
          // ]wy
          GetWindowRect(ParamHandle, R);
          OffsetRect(R, - R.Left, - R.Top);
          BoundsRect := R;
            
          with TDrawThread.Create(Handle) do // إ߹B@֤߰
          begin
            ShowModal; // qX PreviewForm 
            Terminate; // B@֤߰
          end;
        finally
          Free;
        end;
            }
    end;
    
  end;
  
end.

